rm(list = ls())
library("dplyr")
library(reshape)
##################################################################################################################################################################
########### Defining cost, population size other parameters  ####################################################################################################
##################################################################################################################################################################
geno_cost_vec <- c(5, 15, 25,35) # Hypothetical genotyping cost, in US dollars
selected_size_vec <- c( 5,  20,  100,  200) # Vector of parental population selected
total_size_vec    <- c(50, 200, 1000, 2000) # Vector of S0 population generated by random mating the parents
train_pop_size <- 400 # Training population size
train_pop_reps <- 3 # Number of replications for field phenotyping of training population 
gars_cost_crossing <- 38 # Cost of field planting of parents and making crosses, in US dollars
DNA_extrac <- 7 # Cost of DNA extraction, US dollars 
GARS_breeder_Assist_cost<-78000/3 #The fixed costs for breeder and assistant
# PRS costs parameters
bp_pop_size <- 400 # Training population size
selected_size_vec <- c( 5,  20,  100,  200) # Vector of parental population selected
total_size_vec    <- c(50, 200, 1000, 2000) # Vector of S0 population generated by random mating the parents
bp_S1_pop_reps <- 3 # Number of replications for field phenotyping of base and S1 population 
prs_cost_crossing <- 38 # Cost of field planting of parents and making crosses
prs_cost_S0 <- 14 # Cost of field phenotyping
prs_cost_S1 <- 33 # Cost of field phenotyping
cost_training <- 33 # Cost of field phenotyping
bp_pheno_cost <- train_pop_size * cost_training * train_pop_reps
PRS_breeder_Assist_cost<-78000 #The fixed costs for breeder and assistant 
train_geno_cost <- geno_cost_vec * train_pop_size
train_pheno_cost <- train_pop_size * cost_training * train_pop_reps

max_years <- 10; cycles_per_year_gars3 <- 3; cycles_per_year_gars2 <- 2; max_cycles <- 28; prs_cycles <- seq(from=1.0, to=max_years, by=1.0); updated_cycles_gars3 <- seq(from=cycles_per_year_gars3, to=max_cycles, by=cycles_per_year_gars3); updated_cycles_gars2 <- seq(from=cycles_per_year_gars2, to=max_cycles, by=cycles_per_year_gars2)
#Cycle <- c("1.0","1.3","1.6","2.0","2.3","2.6","3.0","3.3","3.6","4.0","4.3","4.6","5.0","5.3","5.6","6.0","6.3","6.6","7.0","7.3","7.6","8.0","8.3","8.6","9.0","9.3","9.6","10.0") #for GARS3
Cycle <- c("1.0", "1.5", "2.0", "2.5", "3.0", "3.5", "4.0", "4.5", "5.0", "5.5", "6.0", "6.5", "7.0", "7.5", "8.0", "8.5", "9.0", "9.5", "10.0") #for GARS2
PRS_Cycle <- c("1.0", "2.0", "3.0", "4.0", "5.0", "6.0", "7.0", "8.0", "9.0", "10.0")
##################################################################################################################################################################
###########Calculating total cost for the different population sizes, genotyping and phenotyping costs ###########################################################
##################################################################################################################################################################
gars_cost <- data.frame(NA)
for( i in geno_cost_vec){
  #Calculate total GARS cost
  gars_cost_cross=(gars_cost_crossing * selected_size_vec)
  gars_cost_dnaExtr <-(total_size_vec*DNA_extrac)
  gars_cost_pop=(i * total_size_vec)
  total_gars_cost=(gars_cost_cross+gars_cost_dnaExtr+gars_cost_pop)
  total_gars_cost <- data.frame (total_gars_cost)
  total_gars_cost <- (total_gars_cost)
  #res_mat <- total_gars_cost
  gars_cost1 <- data.frame(total_gars_cost)
  gars_cost <- cbind(gars_cost, gars_cost1)
  
  #Calculate total PRS cost
  prs_cost_cross = selected_size_vec * prs_cost_crossing
  prs_cost_pop_S0 = total_size_vec * prs_cost_S0
  prs_cost_pop_S1 = total_size_vec * prs_cost_S1 *train_pop_reps
  total_prs_cost = prs_cost_cross + prs_cost_pop_S0 + prs_cost_pop_S1
  total_prs_cost <- data.frame(total_prs_cost)
} 
##################################################################################################################################################################
###########Calculating total cost for the different population sizes, genotyping and phenotyping costs ###########################################################
##################################################################################################################################################################
gars_prs_cost <- cbind(gars_cost, total_prs_cost)
gars_prs_cost$NA. <- c("p5p50", "p20p200", "p100p1000", "p200p2000") 
row.names(gars_prs_cost) <-c("p5p50", "p20p200", "p100p1000", "p200p2000")
colnames(gars_prs_cost) <- c("PS", "A", "B", "C", "D", "E")
p5p50 <- gars_prs_cost["p5p50", ]
p20p200 <- gars_prs_cost["p20p200", ]
p100p1000 <- gars_prs_cost["p100p1000", ]
p200p2000 <- gars_prs_cost["p200p2000", ]
row.names(p5p50) <- NULL; row.names(p20p200) <- NULL; row.names(p100p1000) <- NULL; row.names(p200p2000) <- NULL;
p5p50 <- data.frame(Cycle, p5p50)
##################################################################################################################################################################
##################################################################################################################################################################
row.names(p5p50) <- Cycle
p5p50["1.0", c("A", "B", "C", "D")] <- p5p50["1.0", c("A", "B", "C", "D")] + train_pheno_cost + train_geno_cost
p5p50["1.0", c("E")] <- p5p50["1.0", c("E")] 
p5p50[, c("A", "B", "C", "D", "E")] <- cumsum(p5p50[, c("A", "B", "C", "D", "E")])
GARS3_Cost_p5p50 <- p5p50[ , c("Cycle", "PS", "A", "B", "C", "D")]
GARS3_Cost_p5p50 <- melt(GARS3_Cost_p5p50, id=c("Cycle","PS"))
PRS_Cost_p5p50 <- p5p50[ , c("Cycle", "PS", "E")]
PRS_Cost_p5p50 <- PRS_Cost_p5p50[prs_cycles, ]
PRS_Cost_p5p50 <- melt(PRS_Cost_p5p50, id=c("Cycle","PS"))
PRS_Cost_p5p50 <- PRS_Cost_p5p50[ ,c("PS", "variable", "value")]
PRS_Cost_p5p50 <- data.frame(PRS_Cycle,PRS_Cost_p5p50); colnames(PRS_Cost_p5p50) <- c("Cycle", "PS", "variable", "value")
dim(GARS3_Cost_p5p50)
##################################################################################################################################################################
##################################################################################################################################################################
p20p200 <- data.frame(Cycle, p20p200)
row.names(p20p200) <- Cycle
p20p200["1.0", c("A", "B", "C", "D")] <- p20p200["1.0", c("A", "B", "C", "D")] + train_pheno_cost + train_geno_cost
p20p200["1.0", c("E")] <- p20p200["1.0", c("E")] 
p20p200[, c("A", "B", "C", "D", "E")] <- cumsum(p20p200[, c("A", "B", "C", "D", "E")])
GARS3_Cost_p20p200 <- p20p200[ , c("Cycle", "PS", "A", "B", "C", "D")]
GARS3_Cost_p20p200 <- melt(GARS3_Cost_p20p200, id=c("Cycle","PS"))
PRS_Cost_p20p200 <- p20p200[ , c("Cycle", "PS", "E")]
PRS_Cost_p20p200 <- PRS_Cost_p20p200[prs_cycles, ]
PRS_Cost_p20p200 <- melt(PRS_Cost_p20p200, id=c("Cycle","PS"))
PRS_Cost_p20p200 <- PRS_Cost_p20p200[ ,c("PS", "variable", "value")]
PRS_Cost_p20p200 <- data.frame(PRS_Cycle,PRS_Cost_p20p200); colnames(PRS_Cost_p20p200) <- c("Cycle", "PS", "variable", "value")
##################################################################################################################################################################
##################################################################################################################################################################
p100p1000 <- data.frame(Cycle, p100p1000)
row.names(p100p1000) <- Cycle
p100p1000["1.0", c("A", "B", "C", "D")] <- p100p1000["1.0", c("A", "B", "C", "D")] + train_pheno_cost + train_geno_cost
p100p1000["1.0", c("E")] <- p100p1000["1.0", c("E")] 
p100p1000[, c("A", "B", "C", "D", "E")] <- cumsum(p100p1000[, c("A", "B", "C", "D", "E")])
GARS3_Cost_p100p1000 <- p100p1000[ , c("Cycle", "PS", "A", "B", "C", "D")]
GARS3_Cost_p100p1000 <- melt(GARS3_Cost_p100p1000, id=c("Cycle","PS"))
PRS_Cost_p100p1000 <- p100p1000[ , c("Cycle", "PS", "E")]
PRS_Cost_p100p1000 <- PRS_Cost_p100p1000[prs_cycles, ]
PRS_Cost_p100p1000 <- melt(PRS_Cost_p100p1000, id=c("Cycle","PS"))
PRS_Cost_p100p1000 <- PRS_Cost_p100p1000[ ,c("PS", "variable", "value")]
PRS_Cost_p100p1000 <- data.frame(PRS_Cycle,PRS_Cost_p100p1000); colnames(PRS_Cost_p100p1000) <- c("Cycle", "PS", "variable", "value")
##################################################################################################################################################################
##################################################################################################################################################################
p200p2000 <- data.frame(Cycle, p200p2000)
row.names(p200p2000) <- Cycle
p200p2000["1.0", c("A", "B", "C", "D")] <- p200p2000["1.0", c("A", "B", "C", "D")] + train_pheno_cost + train_geno_cost
p200p2000["1.0", c("E")] <- p200p2000["1.0", c("E")] 
p200p2000[, c("A", "B", "C", "D", "E")] <- cumsum(p200p2000[, c("A", "B", "C", "D", "E")])
GARS3_Cost_p200p2000 <- p200p2000[ , c("Cycle", "PS", "A", "B", "C", "D")]
GARS3_Cost_p200p2000 <- melt(GARS3_Cost_p200p2000, id=c("Cycle","PS"))
PRS_Cost_p200p2000 <- p200p2000[ , c("Cycle", "PS", "E")]
PRS_Cost_p200p2000 <- PRS_Cost_p200p2000[prs_cycles, ]
PRS_Cost_p200p2000 <- melt(PRS_Cost_p200p2000, id=c("Cycle","PS"))
PRS_Cost_p200p2000 <- PRS_Cost_p200p2000[ ,c("PS", "variable", "value")]
PRS_Cost_p200p2000 <- data.frame(PRS_Cycle,PRS_Cost_p200p2000); colnames(PRS_Cost_p200p2000) <- c("Cycle", "PS", "variable", "value")
##################################################################################################################################################################
##################################################################################################################################################################
GARS3_Cost_All_A<-rbind(GARS3_Cost_p5p50, GARS3_Cost_p20p200, GARS3_Cost_p100p1000, GARS3_Cost_p200p2000)
GARS3_Cost_All_B <- GARS3_Cost_All_A
GARS3_Cost_All_C <- GARS3_Cost_All_A
GARS3_Cost_All <- rbind(GARS3_Cost_All_B, GARS3_Cost_All_C)
head(GARS3_Cost_All)

PRS_Cost_All_A <-rbind(PRS_Cost_p5p50, PRS_Cost_p20p200, PRS_Cost_p100p1000, PRS_Cost_p200p2000)
PRS_Cost_All_B <- PRS_Cost_All_A
PRS_Cost_All_C <- PRS_Cost_All_A
PRS_Cost_All <- rbind(PRS_Cost_All_B, PRS_Cost_All_C)
GARS3_PRS_Cost_All<-rbind(GARS3_Cost_All,PRS_Cost_All)
write.csv(GARS3_PRS_Cost_All, file = "Today.csv")
dim(GARS3_PRS_Cost_All)

genetic_gain<-read.csv("genetic_gain_gars2_prs.csv", header = TRUE) #for GARS2
#genetic_gain<-read.csv("genetic_gain_gars3_prs.csv", header = TRUE) #for GARS3
cost_per_gain<-cbind(GARS3_PRS_Cost_All,genetic_gain)
tail(cost_per_gain)
cost_per_gain$newColumn <- cost_per_gain$value/(cost_per_gain$genetic_gain_sd*1000)
head(cost_per_gain)
write.csv(cost_per_gain, file = "cost_per_gain_kkkkk.csv")

##############################################################################################################
######### Ploting the results - Population size of Par20Pop200 ###############################################
##############################################################################################################
include_list <- c("p5p50")
GARS_PRS_Cost_p5p50 <- cost_per_gain[ which(cost_per_gain$PS %in% include_list), ]
colnames(GARS_PRS_Cost_p5p50) <- c("Gen","PS1","PS","Costt","Gen2", "Genet_Arch", "Select_method", "Parm", "genetic_gain_sd", "costpergain")
write.csv(GARS_PRS_Cost_p5p50, file = "GARS2_PRS_Cost_p5p50.csv")
head(GARS_PRS_Cost_p5p50)
tail(GARS_PRS_Cost_p5p50)
library(Rmisc)
library(ggplot2) 
library(gridExtra)
GARS_PRS_Cost_p5p50<-read.csv("GARS2_PRS_Cost_p5p50.csv", header = TRUE)

ggplot(GARS_PRS_Cost_p5p50, aes(x=Gen, y=costpergain,colour=PS, shape=PS)) + 
  geom_point(size=2.5) +
  geom_line()+
  theme(legend.position = "top")+
  facet_grid(
    ~Genet_Arch,
    labeller = labeller(Genet_Arch = c('2' = "Polygenic and low heritability", '1' = "Oligogenic and high heritability")))+
  #theme_classic()+
  scale_colour_manual(name = "Cost",
                      labels = c("Geno_cost5","Geno_cost15","Geno_cost25","Geno_cost35","Pheno_cost"),
                      values = c("turquoise4", "turquoise4", "turquoise4", "turquoise4", "red"))+
  scale_shape_manual(name = "Cost",
                     labels = c("Geno_cost5","Geno_cost15","Geno_cost25","Geno_cost35","Pheno_cost"),
                     values = c(8, 17, 19, 13,15))+
  theme(strip.text = element_text(size=12),
        strip.background = element_rect(colour="grey51", fill="grey91"))+
  theme(legend.text = element_text(colour="black", size = 12))+
  theme(legend.position = "top")+
  ylab("Cost Per Unit gain (in '000 USD)") + xlab  ("Years")+
  annotate("text", size=6,x = 9.5, y = 40, label = letters[1:2])+
  theme(axis.text = element_text(colour="black", size = 14))+
  theme(axis.title = element_text(size = 12, face="bold"))+
  scale_x_continuous(breaks = c(1,3, 5, 7 ,9))
##############################################################################################################
######### Ploting the results - Population size of Par5Pop50 #################################################
##############################################################################################################
include_list <- c("p20p200")
GARS_PRS_Cost_p20p200 <- cost_per_gain[ which(cost_per_gain$PS %in% include_list), ]
colnames(GARS_PRS_Cost_p20p200) <- c("Gen","PS1","PS","Costt","Gen2", "Genet_Arch", "Select_method", "Parm", "genetic_gain_sd", "costpergain")
write.csv(GARS_PRS_Cost_p20p200, file = "GARS2_PRS_Cost_p20p200.csv")
head(GARS_PRS_Cost_p20p200)
tail(GARS_PRS_Cost_p20p200)
library(Rmisc)
library(ggplot2) 
library(gridExtra)
GARS_PRS_Cost_p20p200<-read.csv("GARS2_PRS_Cost_p20p200.csv", header = TRUE)

ggplot(GARS_PRS_Cost_p20p200, aes(x=Gen, y=costpergain,colour=PS, shape=PS)) + 
  geom_point(size=2.5) +
  geom_line()+
  theme(legend.position = "top")+
  facet_grid(
    ~Genet_Arch,
    labeller = labeller(Genet_Arch = c('2' = "Polygenic and low heritability", '1' = "Oligogenic and high heritability")))+
  #theme_classic()+
  scale_colour_manual(name = "Cost",
                      labels = c("Geno_cost5","Geno_cost15","Geno_cost25","Geno_cost35","Pheno_cost"),
                      values = c("turquoise4", "turquoise4", "turquoise4", "turquoise4", "red"))+
  scale_shape_manual(name = "Cost",
                     labels = c("Geno_cost5","Geno_cost15","Geno_cost25","Geno_cost35","Pheno_cost"),
                     values = c(8, 17, 19, 13,15))+
  theme(strip.text = element_text(size=12),
        strip.background = element_rect(colour="grey51", fill="grey91"))+
  theme(legend.text = element_text(colour="black", size = 12))+
  theme(legend.position = "top")+
  ylab("Cost Per Unit gain (in '000 USD)") + xlab  ("Years")+
  annotate("text", size=6,x = 9.5, y = 55, label = letters[3:4])+
  theme(axis.text = element_text(colour="black", size = 14))+
  theme(axis.title = element_text(size = 12, face="bold"))+
  scale_x_continuous(breaks = c(1,3, 5, 7 ,9))
##############################################################################################################
######### Ploting the results - Population size of Par5Pop50 #################################################
##############################################################################################################

include_list <- c("p100p1000")
GARS_PRS_Cost_p100p1000 <- cost_per_gain[ which(cost_per_gain$PS %in% include_list), ]
colnames(GARS_PRS_Cost_p100p1000) <- c("Gen","PS1","PS","Costt","Gen2", "Genet_Arch", "Select_method", "Parm", "genetic_gain_sd", "costpergain")
write.csv(GARS_PRS_Cost_p100p1000, file = "GARS2_PRS_Cost_p100p1000.csv")
head(GARS_PRS_Cost_p100p1000)
tail(GARS_PRS_Cost_p100p1000)
library(Rmisc)
library(ggplot2) 
library(gridExtra)
GARS_PRS_Cost_p100p1000<-read.csv("GARS2_PRS_Cost_p100p1000.csv", header = TRUE)

ggplot(GARS_PRS_Cost_p100p1000, aes(x=Gen, y=costpergain,colour=PS, shape=PS)) + 
  geom_point(size=2.5) +
  geom_line()+
  theme(legend.position = "top")+
  facet_grid(
    ~Genet_Arch,
    labeller = labeller(Genet_Arch = c('2' = "Polygenic and low heritability", '1' = "Oligogenic and high heritability")))+
  #theme_classic()+
  scale_colour_manual(name = "Cost",
                      labels = c("Geno_cost5","Geno_cost15","Geno_cost25","Geno_cost35","Pheno_cost"),
                      values = c("turquoise4", "turquoise4", "turquoise4", "turquoise4", "red"))+
  scale_shape_manual(name = "Cost",
                     labels = c("Geno_cost5","Geno_cost15","Geno_cost25","Geno_cost35","Pheno_cost"),
                     values = c(8, 17, 19, 13,15))+
  theme(strip.text = element_text(size=12),
        strip.background = element_rect(colour="grey51", fill="grey91"))+
  theme(legend.text = element_text(colour="black", size = 12))+
  theme(legend.position = "top")+
  ylab("Cost Per Unit gain (in '000 USD)") + xlab  ("Years")+
  annotate("text", size=6,x = 8.5, y = 180, label = letters[5:6])+
  theme(axis.text = element_text(colour="black", size = 14))+
  theme(axis.title = element_text(size = 12, face="bold"))+
  scale_x_continuous(breaks = c(1,3, 5, 7 ,9))
##############################################################################################################
######### Ploting the results - Population size of Par5Pop50 #################################################
##############################################################################################################
include_list <- c("p200p2000")
GARS_PRS_Cost_p200p2000 <- cost_per_gain[ which(cost_per_gain$PS %in% include_list), ]
colnames(GARS_PRS_Cost_p200p2000) <- c("Gen","PS1","PS","Costt","Gen2", "Genet_Arch", "Select_method", "Parm", "genetic_gain_sd", "costpergain")
write.csv(GARS_PRS_Cost_p200p2000, file = "GARS2_PRS_Cost_p200p2000.csv")
head(GARS_PRS_Cost_p200p2000)
tail(GARS_PRS_Cost_p200p2000)
library(Rmisc)
library(ggplot2) 
library(gridExtra)
GARS_PRS_Cost_p200p2000<-read.csv("GARS2_PRS_Cost_p200p2000.csv", header = TRUE)

ggplot(GARS_PRS_Cost_p200p2000, aes(x=Gen, y=costpergain,colour=PS, shape=PS)) + 
  geom_point(size=2.5) +
  geom_line()+
  theme(legend.position = "top")+
  facet_grid(
    ~Genet_Arch,
    labeller = labeller(Genet_Arch = c('2' = "Polygenic and low heritability", '1' = "Oligogenic and high heritability")))+
  #theme_classic()+
  scale_colour_manual(name = "Cost",
                      labels = c("Geno_cost5","Geno_cost15","Geno_cost25","Geno_cost35","Pheno_cost"),
                      values = c("turquoise4", "turquoise4", "turquoise4", "turquoise4", "red"))+
  scale_shape_manual(name = "Cost",
                     labels = c("Geno_cost5","Geno_cost15","Geno_cost25","Geno_cost35","Pheno_cost"),
                     values = c(8, 17, 19, 13,15))+
  theme(strip.text = element_text(size=12),
        strip.background = element_rect(colour="grey51", fill="grey91"))+
  theme(legend.text = element_text(colour="black", size = 12))+
  theme(legend.position = "top")+
  ylab("Cost Per Unit gain (in '000 USD)") + xlab  ("Years")+
  annotate("text", size=6,x = 9.5, y = 550, label = letters[7:8])+
  theme(axis.text = element_text(colour="black", size = 14))+
  theme(axis.title = element_text(size = 12, face="bold"))+
  scale_x_continuous(breaks = c(1,3, 5, 7 ,9))

##############################################################################################################
######### Ploting the results - Population size of Par5Pop50 #################################################
##############################################################################################################
